=== plugin/src/wscript ===
# -*- python -*-
subdirs = 'fv_converter'

def options(opt):
    opt.recurse(subdirs)

def configure(conf):
    conf.recurse(subdirs)

def build(bld):
    bld.recurse(subdirs)
