=== jubatus/server/cmd/wscript ===
def options(opt): pass

def configure(conf): pass

def build(bld):
  if bld.env.HAVE_ZOOKEEPER_H:
    bld.program(
      source = 'jubactl.cpp',
      target = 'jubactl',
      use = 'MSGPACK ZOOKEEPER_MT JUBATUS_CORE jubaserv_common jubaserv_common_logger jubaserv_framework JUBATUS_MPIO JUBATUS_MSGPACK-RPC MSGPACK'
      )

    bld.program(
      source = 'jubaconfig.cpp',
      target = 'jubaconfig',
      use = 'ZOOKEEPER_MT JUBATUS_CORE jubaserv_common jubaserv_common_logger'
      )


  bld.program(
    source = 'jubaconv.cpp',
    target = 'jubaconv',
    use = 'JUBATUS_CORE jubaserv_common'
    )
