=== jubatus/server/framework/wscript ===
# -*- python -*-
subdirs = 'mixer'

def options(opt):
  opt.recurse(subdirs)

def configure(conf):
  conf.recurse(subdirs)

def build(bld):
  bld.recurse(subdirs)

  framework_source = 'save_load.cpp server_util.cpp server_base.cpp server_helper.cpp'
  if bld.env.HAVE_ZOOKEEPER_H:
    framework_source +=  ' proxy_common.cpp proxy.cpp'

  bld.shlib(
    source = framework_source,
    target = 'jubaserv_framework',
    includes = '.',
    use = 'JUBATUS_CORE MSGPACK JUBATUS_MPIO JUBATUS_MSGPACK_RPC MSGPACK jubaserv_mixer jubaserv_common jubaserv_common_mprpc jubaserv_common_logger',
    vnum = bld.env['ABI_VERSION'],
    )

  def make_test(t):
    bld.program(
      features='gtest',
      source=t + '.cpp',
      target=t,
      includes='.',
      use='jubaserv_framework'
      )

  header_files = [
    'save_load.hpp',
    'server_base.hpp',
    'server_helper.hpp',
    'server_util.hpp',
  ]
  if bld.env.HAVE_ZOOKEEPER_H:
    header_files += [
      'proxy.hpp',
      'proxy_common.hpp',
      'aggregators.hpp'
    ]

  bld.install_files('${PREFIX}/include/jubatus/server/framework', header_files)
